(function(){
	app.custom.formTasks.add('Incident', null, function (formObj, viewModel) { 
		
		var fieldToWatch = 'TierQueue';
		var tabsToHide = ['Activities', 'Related Items'];
		var supportGroupsToHideFor = ['Desktop Support', 'Networking'];
		
		var mainPageNode = document.getElementById('main_wrapper');
		var observer = new MutationObserver(function(mutations) {
			//validate there is a control for the field to watch 
			if ($('[for="' + fieldToWatch + '"]').length > 0) {	
		
				//bind to the change event for the pageForm viewmodel to watch for Support Group changes
				pageForm.viewModel.bind('change',function(e){
					if (e.field === fieldToWatch + '.Name'){
						
						//check if the current support group is in the list of support groups that should hide the list of tabs.
						if (supportGroupsToHideFor.indexOf(pageForm.viewModel[fieldToWatch].Name) > -1){
							//go through each tab in the list of tabs and hide it because the current support group is in the list
							tabsToHide.forEach(function(tab){
								$('li:contains("' + tab + '")').hide();
							})
						}
						else {
							//the support group is not in the hide list, so show the tabs
							tabsToHide.forEach(function(tab){
								$('li:contains("' + tab + '")').show();
							})
						}
						
					}
				});
				//initial hiding if the support group is in the list to hide the tabs for
				if (supportGroupsToHideFor.indexOf(pageForm.viewModel[fieldToWatch].Name) > -1){
					tabsToHide.forEach(function(tab){
						$('li:contains("' + tab + '")').hide();
					});
				}
			
				observer.disconnect();
			}
			else {
				return;
			}
		});
		
		var observerConfig = { attributes: true, childList: true, subtree: true, characterData: true };
		observer.observe(mainPageNode, observerConfig);
	});
})();